"use strict";Object.defineProperty(exports,"__esModule",{value:true});exports.default=exports.ViewportProvider=void 0;var _react=_interopRequireWildcard(require("react"));var _propTypes=_interopRequireDefault(require("prop-types"));var _viewportTypes=_interopRequireWildcard(require("../enums/viewportTypes"));var _capitalizeString=_interopRequireDefault(require("../utils/capitalizeString"));var _checkIfClientSide=_interopRequireDefault(require("../utils/checkIfClientSide"));var _mapServerSideViewportType=_interopRequireDefault(require("../utils/mapServerSideViewportType"));var _findCurrentViewportType=_interopRequireDefault(require("../utils/findCurrentViewportType"));var _mapMediaList=_interopRequireDefault(require("../utils/mapMediaList"));var _mediaWatcher=require("../utils/mediaWatcher");function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj};}function _getRequireWildcardCache(){if(typeof WeakMap!=="function")return null;var cache=new WeakMap();_getRequireWildcardCache=function _getRequireWildcardCache(){return cache;};return cache;}function _interopRequireWildcard(obj){if(obj&&obj.__esModule){return obj;}if(obj===null||typeof obj!=="object"&&typeof obj!=="function"){return{default:obj};}var cache=_getRequireWildcardCache();if(cache&&cache.has(obj)){return cache.get(obj);}var newObj={};var hasPropertyDescriptor=Object.defineProperty&&Object.getOwnPropertyDescriptor;for(var key in obj){if(Object.prototype.hasOwnProperty.call(obj,key)){var desc=hasPropertyDescriptor?Object.getOwnPropertyDescriptor(obj,key):null;if(desc&&(desc.get||desc.set)){Object.defineProperty(newObj,key,desc);}else{newObj[key]=obj[key];}}}newObj.default=obj;if(cache){cache.set(obj,newObj);}return newObj;}var isClientSide=(0,_checkIfClientSide.default)();var defaultViewportTypes=Object.keys(_viewportTypes.default);var mediaList=(0,_mapMediaList.default)();var buildViewportData=function buildViewportData(viewportType){var allViewportTypes=arguments.length>1&&arguments[1]!==undefined?arguments[1]:defaultViewportTypes;var viewportData={viewportType,isPhone:false,isTablet:false,isDesktop:false};for(var i=0;i<allViewportTypes.length;i++){if(allViewportTypes[i]===viewportType){viewportData["is".concat((0,_capitalizeString.default)(viewportType))]=true;return viewportData;}}};var ViewportContext=/*#__PURE__*/(0,_react.createContext)(buildViewportData(_viewportTypes.defaultViewportType));var{Provider}=ViewportContext;var ViewportProvider=(_ref)=>{var{children,customViewportTypes,initialViewportType}=_ref;var viewportTypeValues;if(customViewportTypes){mediaList=(0,_mapMediaList.default)(customViewportTypes);viewportTypeValues=customViewportTypes.map((_ref2)=>{var{viewportType}=_ref2;return viewportType;});}var currentViewportType=isClientSide?(0,_findCurrentViewportType.default)(mediaList):(0,_mapServerSideViewportType.default)({initialViewportType,mediaList,isCustomMediaList:!!customViewportTypes});var[viewportData,setViewportData]=(0,_react.useState)(buildViewportData(currentViewportType,viewportTypeValues));(0,_react.useEffect)(()=>{var onScreenChange=newViewportType=>{setViewportData(buildViewportData(newViewportType,viewportTypeValues));};(0,_mediaWatcher.subscribeMediaWatcher)({mediaList,mediaListener:onScreenChange});var clientViewportType=(0,_findCurrentViewportType.default)(mediaList);if(clientViewportType!==currentViewportType){setViewportData(buildViewportData(clientViewportType,viewportTypeValues));}return _mediaWatcher.unsubscribeMediaWatcher;});return/*#__PURE__*/_react.default.createElement(Provider,{value:viewportData},children);};exports.ViewportProvider=ViewportProvider;ViewportProvider.propTypes={initialViewportType:_propTypes.default.string,customViewportTypes:_propTypes.default.arrayOf(_propTypes.default.shape({viewportType:_propTypes.default.string.isRequired,minWith:_propTypes.default.number,maxWidth:_propTypes.default.number})),children:_propTypes.default.node};ViewportProvider.defaultProps={initialViewportType:_viewportTypes.defaultViewportType,children:null,customViewportTypes:undefined};var _default=ViewportContext;exports.default=_default;